#include <stdio.h>
#include <stdlib.h>
#include "../runtime/db_vm.h"

uint8_t *vmimage;
uint8_t vmdata[65535];

void VM_sysinit(int argc, char *argv[], const uint8_t **image, uint8_t **data, uint16_t *dataSize)
{
    FILE *fp;
    long size;

    if (argc < 2) {
        fprintf(stderr, "usage: vmwin <image-file>\n");
        exit(1);
    }
    else if (!(fp = fopen(argv[1], "rb"))) {
        fprintf(stderr, "error: can't open %s\n", argv[1]);
        exit(1);
    }

    fseek(fp, 0, SEEK_END);
    size = ftell(fp);
    fseek(fp, 0, SEEK_SET);

    if (!(vmimage = (uint8_t *)malloc(size))) {
        fprintf(stderr, "error: insufficient memory\n");
        exit(1);
    }

    fread(vmimage, 1, size, fp);

    *image = vmimage;
    *data = vmdata;
    *dataSize = (uint16_t)sizeof(vmdata);

    fclose(fp);
}

int VM_getchar(void)
{
    return -1;
}

void VM_putchar(int ch)
{
	putchar(ch);
}

void VM_flush(void)
{
	fflush(stdout);
}

int vsnprintf(char *str, size_t size, const char *format, va_list ap)
{
    return vsprintf(str, format, ap);
}
